from string import Template
 
   
headerTemplate = Template("""\
<!--###############################################################################
#
# This file is auto-generated by OpenClovis IDE version 3.1
#
# ${FileName}
#
# 
################################################################################-->

""")


corMetaStructHeaderTemplate = Template("""\
/*******************************************************************************
*
* This file is auto-generated by OpenClovis IDE version 3.1
*
* ${FileName}
* 
*
********************************************************************************/
#ifndef _CL_COR_META_STRUCT_H_
#define _CL_COR_META_STRUCT_H_

#ifdef __cplusplus
extern "C" {
#endif

""")


corDataTemplate = Template("""\

<corMetaDataT>
    ${omEntries}
    <corClassTreeDefT>
         <!-- The Alarm definitions are static. The user is not supposed to modify these definitions. -->
     <corClassDefT className="CLALARMBASECLASS" classId="1" superClassName="">
        <corClassSimpleAttrDefT>
            <corClassSimpleAttrT attrName="CLCONTAINMENTATTRVALIDENTRY" attrId="1" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255" attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
        </corClassSimpleAttrDefT>
    </corClassDefT>

    <corClassDefT className="ALARMINFO" classId="2" superClassName="CLALARMBASECLASS">
        <corClassSimpleAttrDefT>
            <corClassSimpleAttrT attrName="PROBABLECAUSE" attrId="17" attrDataType="CL_COR_UINT32" attrInitVal="0" attrMinVal="0" attrMaxVal="65535"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="GENERATIONRULE" attrId="22" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="SUPPRESSIONRULE" attrId="23" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="GENERATIONRULERELATION" attrId="24" attrDataType="CL_COR_UINT32" attrInitVal="0" attrMinVal="0" attrMaxVal="65535"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="SUPPRESSIONRULERELATION" attrId="25" attrDataType="CL_COR_UINT32" attrInitVal="0" attrMinVal="0" attrMaxVal="65535"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="AFFECTEDALARMS" attrId="21" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="ALARMENABLE" attrId="28" attrDataType="CL_COR_UINT8" attrInitVal="1" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="ALARMSUSPEND" attrId="27" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="ALARMACTIVE" attrId="26" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="ALARMCLEAR" attrId="29" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="CATEGORY" attrId="18" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="SPECIFIC_PROBLEM" attrId="19" attrDataType="CL_COR_UINT32" attrInitVal="0" attrMinVal="0" attrMaxVal="2147483647"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="SEVERITY" attrId="20" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT attrName="EVENTTIME" attrId="30" attrDataType="CL_COR_INT64" attrInitVal="0" attrMinVal="0" attrMaxVal="9223372036854775807"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
        </corClassSimpleAttrDefT>
    </corClassDefT>

    
        ${classDefEntries}
    </corClassTreeDefT>
    <corMoMsoClassTreeDefT>
        ${moMsoClassDefEntries}
     </corMoMsoClassTreeDefT>
</corMetaDataT>
""")
omTemplate = Template("""\
    <OmClassesT>
        ${omClassDataEntries}
    </OmClassesT>
""")
omDataTemplate = Template("""\
    <OmClassDataT className="${omClassName}" classId="${omClassId}"/>
""")

corClassTemplate = Template("""\

<corClassDefT className="${className}" classId="${classRdn}" superClassName="${superClassName}">
 <corClassSimpleAttrDefT>
    ${simpleAttrDefEntries}
 </corClassSimpleAttrDefT>
 <corClassArrAttrDefT>
    ${arrAttrDefEntries}
 </corClassArrAttrDefT>
 <corClassContAttrDefT>
    ${containedAttrDefEntries}
 </corClassContAttrDefT>
 <corClassAssocAttrDefT>
    ${associationAttrDefEntries}
 </corClassAssocAttrDefT>
</corClassDefT>
""")

alarmMsoClassTemplate = Template("""\
 <corClassDefT className="${msoClassName}" classId="${msoClassId}" superClassName="">
         <corClassSimpleAttrDefT>
            <corClassSimpleAttrT  attrName="ALMSTOBEPOLLED" attrId="9" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT  attrName="ALARMPOLLINGINTERVAL" attrId="6" attrDataType="CL_COR_UINT32" attrInitVal="0" attrMinVal="0" attrMaxVal="65535"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT  attrName="ALMS_AFTER_SOAKING_BITMAP" attrId="11" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT  attrName="PUBLISHEDALARMS" attrId="7" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT  attrName="SUPPRESSEDALARMS" attrId="8" attrDataType="CL_COR_UINT64" attrInitVal="0" attrMinVal="0" attrMaxVal="18446744073709551616"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
            <corClassSimpleAttrT  attrName="PARENTENTITYFAILED" attrId="10" attrDataType="CL_COR_UINT8" attrInitVal="0" attrMinVal="0" attrMaxVal="255"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/> 
        </corClassSimpleAttrDefT>

        <corClassArrAttrDefT>
            <corClassArrAttrT attrName="PROBABLECAUSE" attrId="14" attrDataType="CL_COR_UINT32" attrArraySize="64"  attrType="CONFIG" attrInitialized="FALSE" attrWritable="TRUE"/>
        </corClassArrAttrDefT>

        <corClassContAttrDefT>
            <corClassContAttrT attrName="ALMINFOCONTCLASS" attrId="3" containedClassName="ALARMINFO" maxInst="64"/>
        </corClassContAttrDefT>
</corClassDefT>


""")
corSimpleAttrTemplate = Template("""\
    <corClassSimpleAttrT attrName="${attrName}" attrId="${attrId}" attrDataType="${attrDataType}" attrInitVal="${defaultVal}" attrMinVal="${minVal}" attrMaxVal="${maxVal}"  attrType="${attrType}" attrPersistency="${isPersistent}" attrCaching="${isCached}"/>
""")

corSimpleAttrConfigTemplate = Template("""\
    <corClassSimpleAttrT attrName="${attrName}" attrId="${attrId}" attrDataType="${attrDataType}" attrInitVal="${defaultVal}" attrMinVal="${minVal}" attrMaxVal="${maxVal}"  attrType="${attrType}" attrInitialized="${isInitialized}" attrWritable="${isWritable}"/>
""")

corArrayAttrTemplate = Template("""\
    <corClassArrAttrT attrName="${attrName}" attrId="${attrId}" attrDataType="${attrDataType}" attrArraySize="${arrSize}"  attrType="${attrType}" attrPersistency="${isPersistent}" attrCaching="${isCached}"/>
""")

corArrayAttrConfigTemplate = Template("""\
    <corClassArrAttrT attrName="${attrName}" attrId="${attrId}" attrDataType="${attrDataType}" attrArraySize="${arrSize}"  attrType="${attrType}" attrInitialized="${isInitialized}" attrWritable="${isWritable}"/>
""")

corContainedAttrTemplate = Template("""\
    <corClassContAttrT attrName="${attrName}" attrId="${attrId}" containedClassName="${contClassName}" minInst="${minInstance}" maxInst="${maxInstance}"  attrType="${attrType}" attrPersistency="${isPersistent}" attrCaching="${isCached}"/>
""")

corContainedAttrConfigTemplate = Template("""\
    <corClassContAttrT attrName="${attrName}" attrId="${attrId}" containedClassName="${contClassName}" minInst="${minInstance}" maxInst="${maxInstance}"  attrType="${attrType}" attrInitialized="${isInitialized}" attrWritable="${isWritable}/>
""")

corAssociatedAttrTemplate = Template("""\
    <corClassAssocAttrT attrName="${attrName}" attrId="${attrId}" associatedClassName="${assocClassName}" maxAssoc="${maxAssoc}"  attrType="${attrType}" attrPersistency="${isPersistent}" attrCaching="${isCached}"/>
""")

corAssociatedAttrConfigTemplate = Template("""\
    <corClassAssocAttrT attrName="${attrName}" attrId="${attrId}" associatedClassName="${assocClassName}" maxAssoc="${maxAssoc}"  attrType="${attrType}" attrInitialized="${isInitialized}" attrWritable="${isWritable}/>
""")

corMoClassTemplate = Template("""\
 <corMoClassDefT moPath="${moPath}" maxInst="${maxInst}">
    ${msoClassDefEntries}
 </corMoClassDefT>
""")

corMsoClassTemplate = Template("""\
 <corMsoClassDefT  className="${msoClassName}" msoType="${msoType}" omClassType="${omClassType}">
 </corMsoClassDefT>

""")

corConfigTemplate = Template("""\
<corConfigInfoT>
    <corConfigT corOHMask="${corOHMask}" corSaveOption="${corSaveOption}"/>
</corConfigInfoT>
""")

attributesEnumsTemplate = Template("""\
enum ENUM_attributes
{
    ATTRIBUTE_RESERVED = 1,
${attributesEnums}
    COR_ATTRIBUTES_MAX
};
""")

classEnumEntryTemplate = Template("""\
    CLASS_${classname}_${suffix} ,
""")

classEnumsTemplate = Template("""\
enum ENUM_classes
{
    CLASS_RESERVED=65536,
    ${classenums}
    COR_CLASS_MAX
};
""")

attributeEnumEntry = Template("""\
    ${attributeEnumName},
""")

attributesEnumsTemplate = Template("""\
enum ENUM_attributes
{
    ATTRIBUTE_RESERVED = 1,
${attributesEnums}
    COR_ATTRIBUTES_MAX
};
""")
